



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU - 2892：area （圆与多边形交 求面积）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU - 2892：area （圆与多边形交 求面积）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 08:02:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>pro：</strong>飞行员去轰炸一个小岛，给出炸弹落地点的位置信息，以及轰炸半径；按顺时针或者逆时针给出小岛的边界点。 求被轰炸的小岛面积。</p>
<p><strong>sol：</strong>即是求圆和多边形的面积交。 （只会套板子的我改头换面，先理解然后手打一遍。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/618974/201904/618974-20190409162105311-1552532639.jpg" /></p>
<p>首先，我们还是用三角剖分多边形，求&ldquo;有向面积&rdquo;，有向面积可以避免凹多边形存在的情况，或者二者相离的情况。</p>
<p>我们把圆心设为起点，然后对于一个三角形，求它和圆的面积交。 此时有4中情况。</p>
<p>1，三角形在圆的内部。&nbsp;&nbsp;&nbsp; 即OA ,OB的出度都不大于r。</p>
<p>2，一个点在圆外，一个点在圆内。 那么交=三角形+扇形。</p>
<p>3，两个点在圆外，且AB与圆无交点，那么交=扇形。</p>
<p>4，两个点在圆外，且AB与圆有交点，那么交=三角形+扇形+三角形。</p>
<p>由于asin还原的区间在[-pi/2，pi/2]，所以我们在用的时候要按照角度分类讨论。</p>
<div>
<pre class="prettyprint linenums">#include&lt;bits/stdc++.h&gt;<br />
#define rep(i,a,b) for(int i=a;i&lt;=b;i++)<br />
using namespace std;<br />
const int maxn=;<br />
const double eps=1e-;<br />
struct point{<br />
    double x,y;<br />
    point(){}<br />
    point(double xx,double yy):x(xx),y(yy){}<br />
};<br />
struct Circle{<br />
    point c; double r;<br />
};<br />
double det(point a,point b){ return a.x*b.y-a.y*b.x;}<br />
double dot(point a,point b){ return a.x*b.x+a.y*b.y;}<br />
point operator *(point a,double t){ return point(a.x*t,a.y*t);}<br />
point operator +(point a,point b){ return point(a.x+b.x,a.y+b.y);}<br />
point operator -(point a,point b){ return point(a.x-b.x,a.y-b.y);}<br />
double Length(point A){return sqrt(dot(A,A));}<br />
int dcmp(double x){<br />
    if(fabs(x)&lt;eps) return ;  if(x&lt;) return -; return ;<br />
}<br />
double TriAngleCircleInsection(Circle C, point A, point B)<br />
{<br />
    point OA=A-C.c,OB=B-C.c;<br />
    point BA=A-B, BC=C.c-B;<br />
    point AB=B-A, AC=C.c-A;<br />
    double DOA=Length(OA),DOB=Length(OB),DAB=Length(AB),r=C.r;<br />
    if(dcmp(det(OA,OB))==) return ; //，三点一线，不构成三角形<br />
    if(dcmp(DOA-C.r)&lt;&amp;&amp;dcmp(DOB-C.r)&lt;) return det(OA,OB)*0.5; //内部<br />
    else if(DOB&lt;r&amp;&amp;DOA&gt;=r) //一内一外<br />
    {<br />
        double x=(dot(BA,BC)+sqrt(r*r*DAB*DAB-det(BA,BC)*det(BA,BC)))/DAB;<br />
        double TS=det(OA,OB)*0.5;<br />
        return asin(TS*(-x/DAB)*/r/DOA)*r*r*0.5+TS*x/DAB;<br />
    }<br />
    else if(DOB&gt;=r&amp;&amp;DOA&lt;r)// 一外一内<br />
    {<br />
        double y=(dot(AB,AC)+sqrt(r*r*DAB*DAB-det(AB,AC)*det(AB,AC)))/DAB;<br />
        double TS=det(OA,OB)*0.5;<br />
        return asin(TS*(-y/DAB)*/r/DOB)*r*r*0.5+TS*y/DAB;<br />
    }<br />
    else if(fabs(det(OA,OB))&gt;=r*DAB||dot(AB,AC)&lt;=||dot(BA,BC)&lt;=)//弧<br />
    {<br />
        if(dot(OA,OB)&lt;){<br />
            if(det(OA,OB)&lt;) return (-acos(-1.0)-asin(det(OA,OB)/DOA/DOB))*r*r*0.5;<br />
            else  return ( acos(-1.0)-asin(det(OA,OB)/DOA/DOB))*r*r*0.5;<br />
        }<br />
        else      return asin(det(OA,OB)/DOA/DOB)*r*r*0.5; //小于90度，以为asin对应的区间是[-90度,90度]<br />
    }<br />
    else //弧+三角形<br />
    {<br />
        double x=(dot(BA,BC)+sqrt(r*r*DAB*DAB-det(BA,BC)*det(BA,BC)))/DAB;<br />
        double y=(dot(AB,AC)+sqrt(r*r*DAB*DAB-det(AB,AC)*det(AB,AC)))/DAB;<br />
        double TS=det(OA,OB)*0.5;<br />
        return (asin(TS*(-x/DAB)*/r/DOA)+asin(TS*(-y/DAB)*/r/DOB))*r*r*0.5 + TS*((x+y)/DAB-);<br />
    }<br />
}<br />
point a[maxn];<br />
int main()<br />
{<br />
    double X,Y,H,X1,Y1,t,r,ans=; int N;<br />
    while(~scanf("%lf%lf%lf%lf%lf%lf",&amp;X,&amp;Y,&amp;H,&amp;X1,&amp;Y1,&amp;r)){<br />
       t=sqrt(H*/);<br />
       X=X+X1*t; Y=Y+Y1*t; Circle C;<br />
       C.c=point(X,Y); C.r=r;<br />
       scanf("%d",&amp;N);<br />
       rep(i,,N) scanf("%lf%lf",&amp;a[i].x,&amp;a[i].y);<br />
       a[N+]=a[];  ans=;<br />
       rep(i,,N) ans+=TriAngleCircleInsection(C,a[i],a[i+]);<br />
       printf("%.2lf\n",fabs(ans));<br />
    }<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390k4dnq.html">【转】XPath的学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlrrdq.html">Netty 异步的、事件驱动的网络应用程序框架和工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/390xn1o9.html">第二个Sprint冲刺事后诸葛亮报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zw7rn8.html">AD10长方形通孔焊盘的画法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gmkx8.html">BootStrap2学习日记6---代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oklerp9.html">第十一章、认识与学习 BASH 管线命令 &lpar;pipe&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv72gzq.html">如何安装SQL Server 2008数据库（带完整图解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzwxoq.html">phonegap学习入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm2erz9.html">alloc &amp;amp&semi; init &amp;amp&semi; dealloc</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1d06n9.html">Python成长之路第二篇（1）&lowbar;数据类型内置函数用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/950r3l68.html">iOS推送介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0lew8.html">SQL 游标的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoe66nq.html">Winsock网络编程笔记（1）----入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mevxzpq.html">AM335x关于LCD屏幕的时钟PLL配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pngv48.html">&lpar;Java&rpar;微信之个人公众账号开发&lpar;二&rpar;&mdash;&mdash;接收并处理用户消息&lpar;下&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9502zm08.html">XML数据读取&mdash;&mdash;Digester简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv253ky9.html">helm一键 安装mariadb-ha（详细）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe0jk8.html">MT【217】韦达定理应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjdd7zq.html">input文本框只能输入数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd2pp38.html">IP编址</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960rvzv9.html">Find a way out of the ClassLoader maze</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj7ov79.html">关于jsp页面的一些知识（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2531pq.html">js之querySelector方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvg6zr8.html">java ArrayList 迭代器快速失败源码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2yg1y9.html">TNS</a>
			</li>
						<li><a href="https://www.batexi.com/a/q254dovq.html">CSS&lpar;一&rpar;属性--border边框</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m20nw6q.html">Netty完成网络通信（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rgrxn9.html">python基础练习。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyykvyjq.html">Android开发---如何操作资源目录中的资源文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j13e2g9.html">实力封装：Unity打包AssetBundle（二）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
